Index: lib/spatial/mapbuilder/lib/model/ModelBase.js
===================================================================
--- lib/spatial/mapbuilder/lib/model/ModelBase.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/model/ModelBase.js	(revision 4307)
@@ -1,8 +1,11 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: ModelBase.js 3953 2008-03-31 10:25:24Z oterral $
 */
 
+// Ensure this object's dependancies are loaded.
+mapbuilder.loadScript(baseDir+"/util/Listener.js");
+
 /**
  * Base Model class to be inherited by all Model objects and provdes methods
  * and properties common to all models.
@@ -32,18 +35,22 @@
     this.id = "MbModel_" + mbIds.getId();
   }
 
-  //get the human readable title for the model
-  var titleNode = modelNode.selectSingleNode("mb:title");
-  if (titleNode) {
-    this.title = titleNode.firstChild.nodeValue;
-  } else {
-    this.title = this.id;
+  /**
+   * Convenient access to Mapbuilder.getProperty
+   * @param property property to get
+   * @param default value to use if property is not set
+   * @return the value for the property
+   */
+  this.getProperty = function(property, defaultValue) {
+    return Mapbuilder.getProperty(modelNode, property, defaultValue);
   }
 
-  // set an empty debug property which turns of alert messages for a
-  // particular model
-  if(modelNode.selectSingleNode("mb:debug"))this.debug="true";
+  //get the human readable title for the model
+  this.title = this.getProperty("mb:title", this.id);
 
+  //set a debug property in config to see alerts for a particular model
+  this.debug = Mapbuilder.parseBoolean(this.getProperty("mb:debug", false));
+
   /**
   * set the initial model URL in config.
   * the URL can also be passed in as a URL parameter by using the model ID 
@@ -51,42 +58,38 @@
   **/
   if (window.cgiArgs[this.id]) {  
     this.url = window.cgiArgs[this.id];
-  } else if (window[this.id]) {  
+  } else if (window[this.id] && typeof window[this.id] == "string") {  
     this.url = window[this.id];
   } else if (modelNode.url) {  
     this.url = modelNode.url;
   } else {
     var defaultModel = modelNode.selectSingleNode("mb:defaultModelUrl");
-    if (defaultModel) this.url = defaultModel.firstChild.nodeValue;
+    if (defaultModel) this.url = getNodeValue(defaultModel);
   }
 
   //set the method property
-  var method = modelNode.selectSingleNode("mb:method");
-  if (method) {
-    this.method = method.firstChild.nodeValue;
-  } else {
-    this.method = "get";
-  }
+  this.method = this.getProperty("mb:method", "get");
 
   //set the namespace property
-  var namespace = modelNode.selectSingleNode("mb:namespace");
-  if (namespace) {
-    this.namespace = namespace.firstChild.nodeValue;
-  }
+  this.namespace = this.getProperty("mb:namespace");
 
   var templateAttr = modelNode.attributes.getNamedItem("template");
   if (templateAttr) {
-    this.template = (templateAttr.nodeValue=="true")?true:false;
+    this.template = Mapbuilder.parseBoolean(templateAttr.nodeValue);
     this.modelNode.removeAttribute("template");
   }
 
   //get the xpath to select nodes from the parent doc
-  var nodeSelectXpath = modelNode.selectSingleNode("mb:nodeSelectXpath");
-  if (nodeSelectXpath) {
-    this.nodeSelectXpath = nodeSelectXpath.firstChild.nodeValue;
-  }
-
+  this.nodeSelectXpath = this.getProperty("mb:nodeSelectXpath");
+  
   /**
+   * Widgets can place configurations in a model. This is an associative
+   * array with the widgetId of the widget that places its configuration
+   * here as key.
+   */
+  this.config = new Array();
+  
+  /**
    * Get the value of a node as selected by an XPath expression.1
    * @param objRef Reference to this node.
    * @param xpath XPath of the node to update.
@@ -96,7 +99,7 @@
     if (!objRef.doc) return null; 
     node=objRef.doc.selectSingleNode(xpath);
     if(node && node.firstChild){
-      return node.firstChild.nodeValue;
+      return getNodeValue(node);
     }else{
       return null;
     }
@@ -157,54 +160,90 @@
         var xmlHttp = new XMLHttpRequest();
         
         var sUri = objRef.url;
-        if ( sUri.indexOf("http://")==0 ) {
-          if (objRef.method == "get") {
+        if ( sUri.indexOf("http://")==0 || sUri.indexOf("https://")==0) {
+          if (objRef.method.toLowerCase() == "get") {
             sUri = getProxyPlusUrl(sUri);
           } else {
             sUri = config.proxyUrl;
           }
         }
+        //alert( "ModelBase:"+objRef.method + " to:"+ sUri+ " " + objRef.url)
+        
         xmlHttp.open(objRef.method, sUri, objRef.async);
-        if (objRef.method == "post") {
+        if (objRef.method.toLowerCase() == "post") {
           xmlHttp.setRequestHeader("content-type",objRef.contentType);
           xmlHttp.setRequestHeader("serverUrl",objRef.url);
         }
         
-        xmlHttp.onreadystatechange = function() {
+         xmlHttp.onreadystatechange = function() {
           objRef.setParam("modelStatus",httpStatusMsg[xmlHttp.readyState]);
           if (xmlHttp.readyState==4) {
             if (xmlHttp.status >= 400) {   //http errors status start at 400
-              var errorMsg = "error loading document: " + sUri + " - " + xmlHttp.statusText + "-" + xmlHttp.responseText;
+              var errorMsg = mbGetMessage("errorLoadingDocument", sUri, xmlHttp.statusText, xmlHttp.responseText);
               alert(errorMsg);
               objRef.setParam("modelStatus",errorMsg);
               return;
             } else {
               //alert(xmlHttp.getResponseHeader("Content-Type"));
-              if ( null==xmlHttp.responseXML ) {
-                alert( "null XML response:" + xmlHttp.responseText );
-              } else {
-                objRef.doc = xmlHttp.responseXML;
+              //if ( null==xmlHttp.responseXML ) {
+              //  alert( "null XML response:" + xmlHttp.responseText );
+              //} else {
+                // Problem with IE is that sometimes the XML files do not get loaded as XML for some reason (especially from disk)
+                // So we need to deal with it here
+
+                if( (xmlHttp.responseXML != null) && (xmlHttp.responseXML.root != null) && (xmlHttp.responseXML.root.children.length>0) ) {
+                  objRef.doc = xmlHttp.responseXML;
+                  if( Sarissa.getParseErrorText(objRef.doc) == Sarissa.PARSED_OK ) {
+                    objRef.finishLoading();      
+                  } else {
+                    alert(mbGetMessage("parseError", Sarissa.getParseErrorText(objRef.doc)));
+                  }
+                  return;
+                } 
+
+                if( xmlHttp.responseText != null ) {
+                  // if that's the case, the xml file is in the responseText
+                  // we have to load it manually 
+                  objRef.doc = Sarissa.getDomDocument();
+                  objRef.doc.async = false;
+                  objRef.doc = (new DOMParser()).parseFromString( xmlHttp.responseText.replace(/>\s+</g, "><"), "text/xml")
+                  if( objRef.doc == null ) {
+                    alert(mbGetMessage("documentParseError", Sarissa.getParseErrorText(objRef.doc)));
+                    // debugger;
+                  } else {
+                    if( Sarissa.getParseErrorText(objRef.doc) == Sarissa.PARSED_OK ) {
+                      objRef.finishLoading();      
+                    } else {
+                      alert(mbGetMessage("parseError", Sarissa.getParseErrorText(objRef.doc)));
+                    }
+                  }
+                  return;
+                }
                 //if (objRef.doc.documentElement.nodeName.search(/exception/i)>=0) {
                 //  objRef.setParam("modelStatus",-1);
-                //  alert("Exception:"+Sarissa.serialize(xmlHttp.responseText));
+                //  alert("Exception:"+(new XMLSerializer()).serializeToString(xmlHttp.responseText));
                 //}
-              }
-              objRef.finishLoading();
+              //}
+              //objRef.finishLoading();
             }
           }
         }
+        
+        var postData = objRef.postData || "";
+        if (typeof postData == "object") {
+          postData = new XMLSerializer().serializeToString(postData);
+        }
+        xmlHttp.send(postData);
 
-        xmlHttp.send(objRef.postData);
-
         if (!objRef.async) {
           if (xmlHttp.status >= 400) {   //http errors status start at 400
-            var errorMsg = "error loading document: " + sUri + " - " + xmlHttp.statusText + "-" + xmlHttp.responseText;
+            var errorMsg = mbGetMessage("errorLoadingDocument", sUri, xmlHttp.statusText, xmlHttp.responseText);
             alert(errorMsg);
             this.objRef.setParam("modelStatus",errorMsg);
             return;
           } else {
             //alert(xmlHttp.getResponseHeader("Content-Type"));
-            if ( null==xmlHttp.responseXML ) alert( "null XML response:" + xmlHttp.responseText );
+            if ( null==xmlHttp.responseXML ) alert(mbGetMessage("nullXmlResponse", xmlHttp.responseText));
             objRef.doc = xmlHttp.responseXML;
             objRef.finishLoading();
           }
@@ -214,6 +253,7 @@
       }
     }
   }
+  this.addListener("reloadModel",this.loadModelDoc, this);
 
   /**
    * Set the model's XML document using an XML object as a parameter.
@@ -237,12 +277,14 @@
   this.finishLoading = function() {
     // the following two lines are needed for IE; set the namespace for selection
     if(this.doc){
+     if(! _SARISSA_IS_SAFARI){
       this.doc.setProperty("SelectionLanguage", "XPath");
       if(this.namespace) Sarissa.setXpathNamespaces(this.doc, this.namespace);
+		}
 
       // Show the newly loaded XML document
-      if(this.debug) alert("Loading Model:"+this.id+" "+Sarissa.serialize(this.doc));
-      this.callListeners("contextLoaded");  //PGC
+      if(this.debug) mbDebugMessage(this, "Loading Model:"+this.id+" "+(new XMLSerializer()).serializeToString(this.doc));
+      
       this.callListeners("loadModel");
     }
   }
@@ -265,13 +307,14 @@
     // assign it an id
     if (objRef.template) {
       var parentNode = objRef.modelNode.parentNode;
-      var newConfigNode;
       if(_SARISSA_IS_IE) {
-        newConfigNode = parentNode.appendChild(modelNode.cloneNode(true));
-      } else {
-        newConfigNode = parentNode.appendChild(objRef.modelNode.ownerDocument.importNode(objRef.modelNode,true));
+        var newConfigNode = parentNode.appendChild(modelNode.cloneNode(true));
       }
+      else {
+        var newConfigNode = parentNode.appendChild(objRef.modelNode.ownerDocument.importNode(objRef.modelNode,true));
+      }
       newConfigNode.removeAttribute("id");  //this will get created automatically
+      newConfigNode.setAttribute("createByTemplate","true");
       //set defaultModelUrl config properties
       model = objRef.createObject(newConfigNode);
       model.callListeners("init");
@@ -292,6 +335,7 @@
    */
   this.deleteTemplates = function() {
     if (this.templates) {
+      var model;
       while( model=this.templates.pop() ) {
         model.setParam("newModel");
         var parentNode = this.modelNode.parentNode;
@@ -299,8 +343,7 @@
       }
     }
   }
-
- /**
+/**
    * save the model by posting it to the serializeUrl, which is defined as a 
    * property of config.
    * @param objRef Pointer to this object.
@@ -307,14 +350,16 @@
    */
   this.saveModel = function(objRef) {
     if (config.serializeUrl) {
-      var response = postLoad(config.serializeUrl, objRef.doc);
+      var response = postGetLoad(config.serializeUrl, objRef.doc ,"text/xml","","");
+       if(! _SARISSA_IS_SAFARI){
       response.setProperty("SelectionLanguage", "XPath");
       Sarissa.setXpathNamespaces(response, "xmlns:xlink='http://www.w3.org/1999/xlink'");
+      }
       var onlineResource = response.selectSingleNode("//OnlineResource");
       var fileUrl = onlineResource.attributes.getNamedItem("xlink:href").nodeValue;
       objRef.setParam("modelSaved", fileUrl);
     } else {
-      alert("serializeUrl must be specified in config to save a model");
+      alert(mbGetMessage("noSerializeUrl"));
     }
   }
 
@@ -328,13 +373,22 @@
    */
   this.createObject = function(configNode) {
     var objectType = configNode.nodeName;
-    var evalStr = "new " + objectType + "(configNode,this);";
-    var newObject = eval( evalStr );
-    if ( newObject ) {
+    //var evalStr = "new " + objectType + "(configNode,this);";
+    //var newObject = eval( evalStr );
+    //hint from Alex Russel alex@dojotoolkit.org so we can compress it
+
+    // If model/tool/widget doesn't exist, exit
+    if (!window[objectType]) {
+      alert(mbGetMessage("errorCreatingObject", objectType));
+      return false;
+    }
+
+    var newObject = new window[objectType](configNode, this);
+    if (newObject) {
       config.objects[newObject.id] = newObject;
       return newObject;
-    } else { 
-      alert("error creating object:" + objectType);
+    } else {
+      alert(mbGetMessage("errorCreatingObject", objectType));
     }
   }
 
@@ -347,7 +401,10 @@
     //loop through all nodes selected from config
     var configObjects = this.modelNode.selectNodes( objectXpath );
     for (var i=0; i<configObjects.length; i++ ) {
+    if(configObjects[i].nodeName != "#text" && configObjects[i].nodeName != "#comment" )
+        {
       this.createObject( configObjects[i]);
+      }
     }
   }
 
@@ -368,7 +425,7 @@
    * @param objRef Pointer to this object.
    */
   this.refresh = function(objRef) {
-    objRef.setParam("refresh",true);
+    objRef.setParam("refresh");
   }
   this.addListener("loadModel",this.refresh, this);
 
Index: lib/spatial/mapbuilder/lib/model/GeoRSS.js
===================================================================
--- lib/spatial/mapbuilder/lib/model/GeoRSS.js	(revision 4306)
+++ lib/spatial/mapbuilder/lib/model/GeoRSS.js	(revision 4307)
@@ -1,12 +1,18 @@
 /*
 License: LGPL as per: http://www.gnu.org/copyleft/lesser.html
-$Id$
+$Id: GeoRSS.js 3882 2008-02-27 15:41:33Z gjvoosten $
 */
 
+// Ensure this object's dependancies are loaded.
+mapbuilder.loadScript(baseDir+"/model/ModelBase.js");
+
 /**
  * Stores a GML Feature or FeatureCollection as defined by the
- * Open GIS Conortium http://opengis.org.
+ * Open Geospatial Consortium (http://www.opengeospatial.org/).
  *
+ * WARNING: This model is only to be used if you do not want to embed the GeoRSS feed
+ * in the context doc. See also MAP-271
+ * @deprecated
  * @constructor
  * @base ModelBase
  * @author Cameron Shorter
@@ -18,9 +24,7 @@
   // Inherit the ModelBase functions and parameters
   ModelBase.apply(this, new Array(modelNode, parent));
 
-  /**
-   * convert coordinates in the GML document to the SRS of the map container, 
-   * if required.  The coordinate values are replaced in the GML document.
+  /** init
    * @param objRef Pointer to this object.
    */
   this.initItems = function(objRef) {
@@ -27,17 +31,14 @@
     var items = objRef.doc.selectNodes("rdf:RDF/rss:item");
     if( items.length == 0 ) {
       items = objRef.doc.selectNodes("atom:feed/atom:entry");
-    }
-    //alert(Sarissa.serialize(objRef.doc) );
-    //alert( "items:"+items.length );
-    
+     }
+   
     for (var i=0; i<items.length; ++i) {
       var item = items[i];
-      item.setAttribute("id", "RSS_Item_"+mbIds.getId());
-      //convert to GML?
+      item.setAttribute("divid", "RSS_Item_"+mbIds.getId());
     }
   }
-  this.addFirstListener("loadModel",this.initItems,this);
+  // OBE this.addFirstListener("loadModel",this.initItems,this);
 
   /**
    * Returns the list of nodes selected by the nodeSelectpath
@@ -56,7 +57,7 @@
     var labelNode = featureNode.selectSingleNode("rss:title");
     if( labelNode == null )
       labelNode = featureNode.selectSingleNode("atom:title");
-    return labelNode?labelNode.firstChild.nodeValue:"No RSS title";
+    return labelNode?getNodeValue(labelNode):mbGetMessage("noRssTitle");
   }
 
   /**
@@ -65,14 +66,10 @@
    * @return ID for this feature
    */
   this.getFeatureId = function(featureNode) {
-    var id = featureNode.getAttribute("id")
+    var id = featureNode.getAttribute("divid")
     if( id )
       return id;
       
-    id = featureNode.getAttribute("atom:id")
-    if( id )
-      return id;
-      
     return "no_id";
   }
 
@@ -83,18 +80,18 @@
    */
   this.getFeaturePoint = function(featureNode) {
     if (featureNode.selectSingleNode("geo:long")) {
-      var pointX = featureNode.selectSingleNode("geo:long").firstChild.nodeValue;
-      var pointY = featureNode.selectSingleNode("geo:lat").firstChild.nodeValue;
+      var pointX = getNodeValue(featureNode.selectSingleNode("geo:long"));
+      var pointY = getNodeValue(featureNode.selectSingleNode("geo:lat"));
       return new Array(pointX, pointY);
     } else {
        var pos = featureNode.selectSingleNode("georss:where/gml:Point/gml:pos")
        if( pos != null ) {
-	     var coordstr = pos.firstChild.nodeValue
-	     //alert("coords:"+coordstr );
-	     var coords = coordstr.split(" ")
-	     var pointX = coords[0]
-	     var pointY = coords[1]
-	     return new Array(pointX, pointY);
+       var coordstr = getNodeValue(pos);
+       //alert("coords:"+coordstr );
+       var coords = coordstr.split(" ")
+       var pointX = coords[0]
+       var pointY = coords[1]
+       return new Array(pointX, pointY);
        } else {
          return new Array(0,0);  //or some other error to return?
        }
@@ -101,7 +98,62 @@
     }
   }
  
+ /**
+   * Returns the geometry for the feature
+   * @param featureNode the feature node to select from
+   * @return the geometric point for the node
+   */
+  this.getFeatureGeometry = function(featureNode) {
+    if (featureNode.selectSingleNode("geo:long")) {
+      var pointX = getNodeValue(featureNode.selectSingleNode("geo:long"));
+      var pointY = getNodeValue(featureNode.selectSingleNode("geo:lat"));
+      return "POINT " + pointX + "," + pointY;
+    } 
+      
+    var pos = featureNode.selectSingleNode("georss:where/gml:Point/gml:pos")
+    if( pos != null ) {
+      var coordstr = getNodeValue(pos);
+      return "POINT " + coordstr;
+    } 
+    
+    var posList = featureNode.selectSingleNode("georss:where/gml:LineString/gml:posList")
+    if( posList != null ) { //WARNING: could overflow so get all nodes
+      var children = posList.childNodes;       
+      var count = children.length;
+      var text="";     
+      for( var i=0; i<count; i++ ) {
+        text += children[i].nodeValue;
+      }
+      //alert("count:"+ count + " length:"+text.length)
+      
+      return "LINESTRING " + text;
+    }
+ 
+    var posList = featureNode.selectSingleNode("georss:where/gml:Polygon/gml:exterior/gml:LinearRing")
+    if( posList != null ) {
+      var coordstr = getNodeValue(posList);
+      return "POLYGON " + coordstr;
+    } 
+    
+    alert(mbGetMessage("invalidGmlGeom"));
+    return null
+  }
+  
   /**
+    * Get the GML Node out of the RSS feed
+    */
+  this.getFeatureGml = function(featureNode) {
+    var where = featureNode.selectSingleNode("georss:where")
+    if( where != null ) {
+      var gml = where.firstChild; 
+      return gml;
+    } else {
+      return null;
+    }
+  }
+  
+  
+  /**
   * Returns a specific icon for that entry
   * @param featureNode the feature node to select from
   * @return the geometric point for the node
@@ -113,11 +165,10 @@
     // look for an icon tag
     var icon = featureNode.selectSingleNode("atom:icon");
     if (icon != undefined) {
-      return icon.firstChild.nodeValue;
+      return getNodeValue(icon);
     } else {
       return null;
     }
   }
-
 }
 
Index: lib/spatial/mapbuilder/lib/schemas/locations.xsd
===================================================================
--- lib/spatial/mapbuilder/lib/schemas/locations.xsd	(revision 4306)
+++ lib/spatial/mapbuilder/lib/schemas/locations.xsd	(revision 4307)
@@ -1,10 +1,10 @@
 <?xml version="1.0" encoding="UTF-8" standalone="no"?>
 <xs:schema targetNamespace="http://mapbuilder.sourceforge.net/mapbuilder" xmlns:gml="http://www.opengis.net/gml" xmlns:loc="http://mapbuilder.sourceforge.net/mapbuilder" xmlns:xs="http://www.w3.org/2001/XMLSchema" elementFormDefault="qualified" attributeFormDefault="unqualified" version="1.0.0">
 	<xs:annotation>
-		<xs:appinfo>$Id$</xs:appinfo>
+		<xs:appinfo>$Id: locations.xsd 2546 2007-01-23 12:07:39Z gjvoosten $</xs:appinfo>
 		<xs:documentation xml:lang="en">GML schema for Community Mapbuilder quickview zoom presets</xs:documentation>
 	</xs:annotation>
-	<xs:import namespace="http://www.opengis.net/gml" schemaLocation="http://schemas.opengis.net/gml/3.0.0/base/feature.xsd"/>
+	<xs:import namespace="http://www.opengis.net/gml" schemaLocation="http://schemas.opengis.net/gml/3.1.1/base/feature.xsd"/>
 	<xs:element name="QuickviewPresetResultSet" type="loc:QuickviewPresetResultSetType" substitutionGroup="gml:_FeatureCollection"/>
 	<xs:complexType name="QuickviewPresetResultSetType">
 		<xs:complexContent>
